using RMYY_CallCenter_Api.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RMYY_CallCenter_Api.Dal
{
    /// <summary>
    /// 数据访问类:T_Sys_Knowledge
    /// </summary>
    public partial class T_Sys_Knowledge
    {
        public T_Sys_Knowledge()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Knowledge");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Sys_Knowledge model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Knowledge(");
            strSql.Append("F_TypeId,F_Title,F_Content,F_Description,F_KeyWords,F_TypeName,F_Files,F_CreateCode,F_CreateName,F_CreateTime,F_ModifyTime,F_ModifyCode,F_ModifyName,F_IsDel)");
            strSql.Append(" values (");
            strSql.Append("@F_TypeId,@F_Title,@F_Content,@F_Description,@F_KeyWords,@F_TypeName,@F_Files,@F_CreateCode,@F_CreateName,@F_CreateTime,@F_ModifyTime,@F_ModifyCode,@F_ModifyName,@F_IsDel)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Description", SqlDbType.NText),
                    new SqlParameter("@F_KeyWords", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_TypeName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Files", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_CreateCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ModifyName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_IsDel", SqlDbType.Int,4)};
            parameters[0].Value = model.F_TypeId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Content;
            parameters[3].Value = model.F_Description;
            parameters[4].Value = model.F_KeyWords;
            parameters[5].Value = model.F_TypeName;
            parameters[6].Value = model.F_Files;
            parameters[7].Value = model.F_CreateCode;
            parameters[8].Value = model.F_CreateName;
            parameters[9].Value = model.F_CreateTime;
            parameters[10].Value = model.F_ModifyTime;
            parameters[11].Value = model.F_ModifyCode;
            parameters[12].Value = model.F_ModifyName;
            parameters[13].Value = model.F_IsDel;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Sys_Knowledge model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Knowledge set ");
            strSql.Append("F_TypeId=@F_TypeId,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_Description=@F_Description,");
            strSql.Append("F_KeyWords=@F_KeyWords,");
            strSql.Append("F_TypeName=@F_TypeName,");
            strSql.Append("F_Files=@F_Files,");
            strSql.Append("F_CreateCode=@F_CreateCode,");
            strSql.Append("F_CreateName=@F_CreateName,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_ModifyTime=@F_ModifyTime,");
            strSql.Append("F_ModifyCode=@F_ModifyCode,");
            strSql.Append("F_ModifyName=@F_ModifyName,");
            strSql.Append("F_IsDel=@F_IsDel");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Description", SqlDbType.NText),
                    new SqlParameter("@F_KeyWords", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_TypeName", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_Files", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_CreateCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ModifyCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ModifyName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_IsDel", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_TypeId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Content;
            parameters[3].Value = model.F_Description;
            parameters[4].Value = model.F_KeyWords;
            parameters[5].Value = model.F_TypeName;
            parameters[6].Value = model.F_Files;
            parameters[7].Value = model.F_CreateCode;
            parameters[8].Value = model.F_CreateName;
            parameters[9].Value = model.F_CreateTime;
            parameters[10].Value = model.F_ModifyTime;
            parameters[11].Value = model.F_ModifyCode;
            parameters[12].Value = model.F_ModifyName;
            parameters[13].Value = model.F_IsDel;
            parameters[14].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Knowledge ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Knowledge ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_Knowledge GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_TypeId,F_Title,F_Content,F_Description,F_KeyWords,F_TypeName,F_Files,F_CreateCode,F_CreateName,F_CreateTime,F_ModifyTime,F_ModifyCode,F_ModifyName,F_IsDel from T_Sys_Knowledge ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            RMYY_CallCenter_Api.Model.T_Sys_Knowledge model = new RMYY_CallCenter_Api.Model.T_Sys_Knowledge();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_Knowledge DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Sys_Knowledge model = new RMYY_CallCenter_Api.Model.T_Sys_Knowledge();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_TypeId"] != null && row["F_TypeId"].ToString() != "")
                {
                    model.F_TypeId = int.Parse(row["F_TypeId"].ToString());
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_Description"] != null)
                {
                    model.F_Description = row["F_Description"].ToString();
                }
                if (row["F_KeyWords"] != null)
                {
                    model.F_KeyWords = row["F_KeyWords"].ToString();
                }
                if (row["F_TypeName"] != null)
                {
                    model.F_TypeName = row["F_TypeName"].ToString();
                }
                if (row["F_Files"] != null)
                {
                    model.F_Files = row["F_Files"].ToString();
                }
                if (row["F_CreateCode"] != null)
                {
                    model.F_CreateCode = row["F_CreateCode"].ToString();
                }
                if (row["F_CreateName"] != null)
                {
                    model.F_CreateName = row["F_CreateName"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_ModifyTime"] != null && row["F_ModifyTime"].ToString() != "")
                {
                    model.F_ModifyTime = DateTime.Parse(row["F_ModifyTime"].ToString());
                }
                if (row["F_ModifyCode"] != null)
                {
                    model.F_ModifyCode = row["F_ModifyCode"].ToString();
                }
                if (row["F_ModifyName"] != null)
                {
                    model.F_ModifyName = row["F_ModifyName"].ToString();
                }
                if (row["F_IsDel"] != null && row["F_IsDel"].ToString() != "")
                {
                    model.F_IsDel = int.Parse(row["F_IsDel"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_TypeId,F_Title,F_Content,F_Description,F_KeyWords,F_TypeName,F_Files,F_CreateCode,F_CreateName,F_CreateTime,F_ModifyTime,F_ModifyCode,F_ModifyName,F_IsDel ");
            strSql.Append(" FROM T_Sys_Knowledge ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_TypeId,F_Title,F_Content,F_Description,F_KeyWords,F_TypeName,F_Files,F_CreateCode,F_CreateName,F_CreateTime,F_ModifyTime,F_ModifyCode,F_ModifyName,F_IsDel ");
            strSql.Append(" FROM T_Sys_Knowledge ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Knowledge ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Knowledge T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }
    
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
